# -*- coding: utf-8 -*-
"""
Created on Sun Jun 16 07:04:51 2019

@author: cg26ryzi
"""

# Import modules ######################
print 'Load modules'
from glob import glob
import os
import numpy as np
import csv
import sys

import arcpy
from arcpy.sa import *

# Check out any necessary licenses ####
arcpy.CheckOutExtension("spatial")
arcpy.env.overwriteOutput = True

#######################################
#######################################
# Set results (output) root ###########
root_results = r'C:\Research\Papers\2019\Pathogens\Spatial_dataset\Results_final122019'

#######################################
#######################################
# Set inputs root #####################

root_folder = r'C:\Research\Papers\2019\Pathogens\Spatial_dataset'

#######################################
#######################################

#Static Datasets
elevation_l = root_folder + '\\Static\\' + 'elevation_log10.tif'
elevation   = root_folder + '\\Static\\' + 'elevation.tif'
texture     = root_folder + '\\Static\\' + 'clay_silt_30_log10.tif'
pH          = root_folder + '\\Static\\' + 'pH0p25_dec_log10.tif'
carbon      = root_folder + '\\Static\\' + 'soil_C_log10.tif'

#Set variables
SSP = ['SSP1','SSP4','SSP5']
year = ['2010','2050']
variable = []

for SSP in SSP:
    print 'Run: ' + str(SSP)
    root_results_ssp = root_results + '\\' + str(SSP)
    if not os.path.exists(root_results_ssp):
        os.makedirs(root_results_ssp)
    #Current
    print 'Run Current'
    Temp = glob(root_folder + '\\Dynamic\\Climate\\' + SSP + '\\tas' + '*2010.tif')
    forest = glob(root_folder + '\\Dynamic\\Vegetation\\forest' + '*2010.tif')
    grassland = glob(root_folder + '\\Dynamic\\Vegetation\\grassland' + '*2010.tif')
    
    name = glob(root_folder + '\\Dynamic\\Climate\\' + SSP + '\\tas' + '*.tif')
    model =[]
    for n in name:
        model.append(n.split('\\tas')[-1].split('_20')[0])
    model = list(set(model))
    
    for m in model:
        t = root_folder + '\\Dynamic\\Climate\\' + SSP + '\\tas' + m +'_2010.tif'
        p = root_folder + '\\Dynamic\\Climate\\' + SSP + '\\pr' + m +'_2010.tif'
        
        pathogens = (0.904921 +
                    (0.014210 * Raster(t)) +
                    (-0.000079 * Raster(p)) +
                    (0.194124 * Raster(forest[0])) +
                    (0.118924 * Raster(grassland[0])) +
                    (0.000087 * Raster(elevation)) +
                    (-0.294697 * Raster(carbon)) +
                    (0.035439 * Raster(texture)))
        
        pathogens_pred = root_results_ssp + '\\' + 'pathogens' + t.split('\\tas')[-1]
        pathogens.save(pathogens_pred)
        variable.append('pathogens')
        
        alternaria = (-0.194281  +
                     (0.011478 * Raster(t)) +
                     (-0.052372 * Raster(forest[0])) +
                     (0.010278 * Raster(grassland[0])) +
                     (0.000108 * Raster(elevation)) +
                     (-0.112749 * Raster(texture)) +
                     (0.912887 * Raster(pH)) +
                     (-0.312929 * Raster(carbon)))
        
        alternaria_pred = root_results_ssp + '\\' + 'alternaria' + t.split('\\tas')[-1]
        alternaria.save(alternaria_pred)
        variable.append('alternaria')
        
        fusarium = (-0.013471 +
                   (0.000147 * Raster(p)) +
                   (0.116522 * Raster(grassland[0])) +
                   (0.408884 * Raster(pH)) +
                   (0.000089 * Raster(elevation)) +
                   (-0.310071 * Raster(carbon)))
        
        fusarium_pred = root_results_ssp + '\\' + 'fusarium' + t.split('\\tas')[-1]
        fusarium.save(fusarium_pred)
        variable.append('fusarium')
        
        phoma = (-0.483244 +
                (0.009364 * Raster(t)) +
                (-0.000110 * Raster(p)) +
                (0.174653 * Raster(forest[0])) +
                (0.013655 * Raster(grassland[0])) +
                (-0.029297 * Raster(texture)) +
                (0.698927 * Raster(pH)) +
                (-0.000035 * Raster(elevation)))
        
        phoma_pred = root_results_ssp + '\\' + 'phoma' + t.split('\\tas')[-1]
        phoma.save(phoma_pred)
        variable.append('phoma')
        
        venturia = (0.400302 +
                   (0.007749 * Raster(t)) +
                   (-0.000184 * Raster(p)) +
                   (0.162433 * Raster(forest[0])) +
                   (0.040770 * Raster(texture)) +
                   (-0.585087 * Raster(pH)) +
                   (0.172813 * Raster(carbon)))
        
        venturia_pred = root_results_ssp + '\\' + 'venturia' + t.split('\\tas')[-1]
        venturia.save(venturia_pred)
        variable.append('venturia')
        
        path_single = (0.293999 +
                       (0.046559 * Raster(elevation_l)) +
                       (0.009662 * Raster(t)) +
                       (-0.000122 * Raster(p)) +
                       (0.226260 * Raster(forest[0])) +
                       (0.104091 * Raster(grassland[0])))
        
        path_single_pred = root_results_ssp + '\\' + 'path_single' + t.split('\\tas')[-1]
        path_single.save(path_single_pred)
        variable.append('path_single')
    
    #Future
    print 'Run Future'
    forest_f = glob(root_folder + '\\Dynamic\\Vegetation\\forest_' + SSP + '_2050.tif')
    grassland_f = glob(root_folder + '\\Dynamic\\Vegetation\\grassland_' + SSP + '_2050.tif')
    
    for m in model:
        t_f = root_folder + '\\Dynamic\\Climate\\' + SSP + '\\tas' + m +'_2050.tif'
        p_f = root_folder + '\\Dynamic\\Climate\\' + SSP + '\\pr' + m +'_2050.tif'
        
        pathogens = (0.904921 +
                    (0.014210 * Raster(t_f)) +
                    (-0.000079 * Raster(p_f)) +
                    (0.194124 * Raster(forest_f[0])) +
                    (0.118924 * Raster(grassland_f[0])) +
                    (0.000087 * Raster(elevation)) +
                    (-0.294697 * Raster(carbon)) +
                    (0.035439 * Raster(texture)))
        
        pathogens_pred = root_results_ssp + '\\' + 'pathogens' + t_f.split('\\tas')[-1]
        pathogens.save(pathogens_pred)
        
        alternaria = (-0.194281  +
                     (0.011478 * Raster(t_f)) +
                     (-0.052372 * Raster(forest_f[0])) +
                     (0.010278 * Raster(grassland_f[0])) +
                     (0.000108 * Raster(elevation)) +
                     (-0.112749 * Raster(texture)) +
                     (0.912887 * Raster(pH)) +
                     (-0.312929 * Raster(carbon)))
        
        alternaria_pred = root_results_ssp + '\\' + 'alternaria' + t_f.split('\\tas')[-1]
        alternaria.save(alternaria_pred)
        
        fusarium = (-0.013471 +
                   (0.000147 * Raster(p_f)) +
                   (0.116522 * Raster(grassland_f[0])) +
                   (0.408884 * Raster(pH)) +
                   (0.000089 * Raster(elevation)) +
                   (-0.310071 * Raster(carbon)))
        
        fusarium_pred = root_results_ssp + '\\' + 'fusarium' + t_f.split('\\tas')[-1]
        fusarium.save(fusarium_pred)
        
        phoma = (-0.483244 +
                (0.009364 * Raster(t_f)) +
                (-0.000110 * Raster(p_f)) +
                (0.174653 * Raster(forest_f[0])) +
                (0.013655 * Raster(grassland_f[0])) +
                (-0.029297 * Raster(texture)) +
                (0.698927 * Raster(pH)) +
                (-0.000035 * Raster(elevation)))
        
        phoma_pred = root_results_ssp + '\\' + 'phoma' + t_f.split('\\tas')[-1]
        phoma.save(phoma_pred)
        
        venturia = (0.400302 +
                   (0.007749 * Raster(t_f)) +
                   (-0.000184 * Raster(p_f)) +
                   (0.162433 * Raster(forest_f[0])) +
                   (0.040770 * Raster(texture)) +
                   (-0.585087 * Raster(pH)) +
                   (0.172813 * Raster(carbon)))
        
        venturia_pred = root_results_ssp + '\\' + 'venturia' + t_f.split('\\tas')[-1]
        venturia.save(venturia_pred)
        
        path_single = (0.293999 +
                       (0.046559 * Raster(elevation_l)) +
                       (0.009662 * Raster(t_f)) +
                       (-0.000122 * Raster(p_f)) +
                       (0.226260 * Raster(forest_f[0])) +
                       (0.104091 * Raster(grassland_f[0])))
        
        path_single_pred = root_results_ssp + '\\' + 'path_single' + t_f.split('\\tas')[-1]
        path_single.save(path_single_pred)
    
    #Change
    print 'Calculate Change'
    print ' '
    variable = list(set(variable))
    
    for v in variable:
        print v
        for m in model:
            norm_array = np.asarray([1])
            for y in year:
                raster_in = root_results_ssp + '\\' + str(v) + m + '_' + str(y) + '.tif'    
                raster_in_np_1 = arcpy.RasterToNumPyArray(raster_in, nodata_to_value=-999)
                tf = raster_in_np_1 > -900
                final_np_in1 = raster_in_np_1[tf,]
                norm_array = np.concatenate((norm_array,final_np_in1))
                        
            min_old = np.amin(norm_array)
            max_old = np.amax(norm_array)
            min_new = 1.0
            max_new = 100.0
            lit = ((max_new - min_new) / (max_old - min_old))
            
            for y in year:
                raster_in = root_results_ssp + '\\' + str(v) + m + '_' + str(y) + '.tif'
                normalized_in = float(lit) * (Raster(raster_in) - float(max_old)) + float(max_new)
                
                normalized = root_results_ssp + '\\' + str(v) + m + '_' + str(y) + '_n.tif'
                normalized_in.save(normalized)
    
            current = root_results_ssp + '\\' + str(v) + m + '_' + '2010_n.tif'
            future  = root_results_ssp + '\\' + str(v) + m + '_' + '2050_n.tif'
            
            change  = (Raster(future) - Raster(current))/Raster(current)
            change_pred = root_results_ssp + '\\' + str(v) + m + '_' + 'change.tif'
            change.save(change_pred)
        
        list_change = glob(root_results_ssp + '\\' + str(v) + '*99_change.tif')
        Output = root_results_ssp + '\\' + str(v) + '_' + str(SSP) + '_change.tif'
        arcpy.gp.CellStatistics_sa(list_change, Output, "MEAN", "DATA")
        
        raster_np = arcpy.RasterToNumPyArray(Output, nodata_to_value=-999)
        tf = raster_np > -900
        final_np = raster_np[tf,]
        
        # Calculate statistics #
        Mean_c = np.average(final_np)  # mean
        print 'Mean: ' + str(Mean_c)
        sd_c = np.std(final_np)
        print 'sd: ' + str(sd_c)
        Q1_c = np.percentile(final_np, 25)  # Q1
        print 'Q1: '+ str(Q1_c)
        Median_c = np.percentile(final_np, 50)  # median
        print 'Median: '+ str(Median_c)
        Q3_c = np.percentile(final_np, 75)  # Q3
        print 'Q3: '+ str(Q3_c)
        print ' '
        
        list_2010 = glob(root_results_ssp + '\\' + str(v) + '*_2010.tif')
        root_average_2010 = root_results + '\\Average_2010'
        if not os.path.exists(root_average_2010):
            os.makedirs(root_average_2010)
        Output_2010 = root_average_2010 + '\\' + str(v) + '_' + str(SSP) + '_2010_m.tif'
        arcpy.gp.CellStatistics_sa(list_2010, Output_2010, "MEAN", "DATA")
        
        list_2050 = glob(root_results_ssp + '\\' + str(v) + '*_2050.tif')
        root_average_2050 = root_results + '\\Average_2050'
        if not os.path.exists(root_average_2050):
            os.makedirs(root_average_2050)
        Output_2050 = root_average_2050 + '\\' + str(v) + '_' + str(SSP) + '_2050_m.tif'
        arcpy.gp.CellStatistics_sa(list_2050, Output_2050, "MEAN", "DATA")
        
print 'Compute Averages'
for v in variable:
    list_2010m = glob(root_results + '\\Average_2010\\' + str(v) + '*_2010_m.tif')
    Output_2010m = root_results + '\\Average_2010\\' + str(v) + '_2010.tif'
    arcpy.gp.CellStatistics_sa(list_2010m, Output_2010m, "MEAN", "DATA")
